import request from '~/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { CmsFormRecord, CmsFormRecordParam } from './model';


/**
 * 分页查询表单数据记录表
 */
export async function pageCmsFormRecord(params: CmsFormRecordParam) {
  const res = await request.get<ApiResult<PageResult<CmsFormRecord>>>(
    '/cms/cms-form-record/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询表单数据记录表列表
 */
export async function listCmsFormRecord(params?: CmsFormRecordParam) {
  const res = await request.get<ApiResult<CmsFormRecord[]>>(
    '/cms/cms-form-record',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加表单数据记录表
 */
export async function addCmsFormRecord(data: CmsFormRecord) {
  const res = await request.post<ApiResult<unknown>>(
    '/cms/cms-form-record',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改表单数据记录表
 */
export async function updateCmsFormRecord(data: CmsFormRecord) {
  const res = await request.put<ApiResult<unknown>>(
    '/cms/cms-form-record',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除表单数据记录表
 */
export async function removeCmsFormRecord(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-form-record/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除表单数据记录表
 */
export async function removeBatchCmsFormRecord(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-form-record/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询表单数据记录表
 */
export async function getCmsFormRecord(id: number) {
  const res = await request.get<ApiResult<CmsFormRecord>>(
    '/cms/cms-form-record/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
